<?php
$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$configfile = '/usr/local/esia/public_html/esia.conf.php';
include_once $configfile;
$rrdpath=RRA_DIRECTORY;
//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
    exit(1);
}
//on prépare la requète qui récupére les informations sur la base rrdtool
$query = $dbconnection->prepare("SELECT rrd_plugin_id,rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_graph_num,rrd_calc FROM rrd_plugins;");
$ret = $query->execute();
if($ret===false)
{
    $err = $query->errorInfo();
    echo "DB error: ".$err[2]."\n";
    exit(0);
}
$arr_rrd_parameter=array();
while($row=$query->fetch(PDO::FETCH_OBJ))
{
    $arr_rrd_parameter[$row->rrd_plugin_id][]=$row;
}
//on recupère les données
$query= $dbconnection->prepare("SELECT DISTINCT service_id,service_name,service_last_stdout,device_name,service_plugin_id,plugin_name
				FROM esia_services
				JOIN esia_device ON device_id = service_device_id
				JOIN esia_plugins ON plugin_id = service_plugin_id
				JOIN rrd_plugins ON rrd_plugin_id=service_plugin_id ORDER BY device_name;");
$ret = $query->execute();
if($ret===false)
{
	$err = $query->errorInfo();
	echo "DB error: ".$err[2]."\n";
	exit(0);
}
while($row=$query->fetch(PDO::FETCH_OBJ))
{
	//on récupère les informations pour le dataSource
    $rows_rrd = $arr_rrd_parameter[$row->service_plugin_id];
	//liste les information pour générer le graphique et les sépares suivant leurs numéros (clé rrd_graph_num)
	$list_graphs=array();
	foreach($rows_rrd as $r)
	{ 
		if(array_key_exists($r->rrd_graph_num,$list_graphs))
		{
			array_push($list_graphs[$r->rrd_graph_num],$r);
		}
		else	
		{
			$list_graphs[$r->rrd_graph_num][]=$r;
		}
	}
	//print_r($list_graphs);
	//on va générer les graphique rrd
	foreach($list_graphs as $rows_rrd)
	{
		//test existence du ficher
        $nodename= preg_replace('#\s#','_',$row->device_name);
        $nodename= preg_replace('#\/#','_',$nodename);
        $nodename= preg_replace('#\\\\#','_',$nodename);
		$filename = $rrdpath.$nodename.'_'.$row->plugin_name.$row->service_id.$rows_rrd[0]->rrd_graph_num.'.rrd';
		if(file_exists($filename)===FALSE)
		{
			//préparation des paramètres
			$opts = array( "--step",$rows_rrd[0]->rrd_time, "--start", 0);
			foreach($rows_rrd as $ds)
			{
				$min='U';
				$max='U';
				if($ds->rrd_min!=-1)
					$min=$ds->rrd_min;
				if($ds->rrd_max!=-1)
					$max=$ds->rrd_max;
				$opts[] ="DS:".$ds->rrd_name.":".$ds->rrd_type.":600:".$min.":".$max;
			}
			$opts[] ="RRA:AVERAGE:0.5:1:600";
			$opts[] ="RRA:AVERAGE:0.5:6:700";
			$opts[] ="RRA:AVERAGE:0.5:24:775";
			$opts[] ="RRA:AVERAGE:0.5:288:797";
			$opts[] ="RRA:MAX:0.5:1:600";
			$opts[] ="RRA:MAX:0.5:6:700";
			$opts[] ="RRA:MAX:0.5:24:775";
			$opts[] ="RRA:MAX:0.5:288:797";
			$ret = rrd_create($filename, $opts);
			if( $ret == 0 )
			{
				$err = rrd_error();
				echo "Create error: $err\n";
			}
		}
		//on execute la regex et on met à jour la base rrd
		$com_ds='';
		$com_value='';
		foreach($rows_rrd as $ds)
		{
			if(!empty($com_ds))
			{
				$com_ds.=':';
			}
			if(empty($com_value))
			{
				$com_value='N:';
			}
			else
			{
				$com_value.=':';
			}
			$com_ds.= $ds->rrd_name;
			if(preg_match($ds->rrd_regex,$row->service_last_stdout,$regs))
			{
				$value = preg_replace('#,#','.',$regs[1]);
				if(preg_match('#([\*\/\+\-\%])([0-9]*)#',$ds->rrd_calc,$calc))
				{
					switch($calc[1])
					{
						case '+': $value=$value+$calc[2];  break;
						case '-': $value=$value-$calc[2];  break;
						case '*': $value=$value*$calc[2];  break;
						case '/': $value=$value/$calc[2];  break;
						case '%': $value=$value%$calc[2];  break;
						default: break;
					}
				}
				$com_value.= $value;
			}
			else
			{
				$com_value.='U';
			}
		}
		echo $row->device_name.' '.$row->plugin_name.':'." DS: $com_ds=>$com_value $filename\n"; 
		$parameter =array('-t',$com_ds,$com_value);
		//print_r($parameter);
		$ret = rrd_update($filename,$parameter);
		if( $ret == 0 )
		{
			$err = rrd_error();
			echo "update error: $err\n";
		}
	}

}


?>
